<template>
<div id="app">
	<encabezado/>
	<main>
		<transition
			name="fade"
			mode="out-in"
		>
			<router-view/>
		</transition>
		<router-view name="disco" />
	</main>
	<input class="archivos" type="file"
		@change="fileChanged"
		ref="archivos"
		multiple>
	<section class="subidas" v-if="subida.length">
		<Subida v-for="operacion in subida"
			:key="operacion.id"
			:idu="operacion.id"
			:archivo="operacion.archivo"
			@terminada="subidaTerminada"/>
	</section>
	<pie/>
</div>
</template>

<script>
import Encabezado from "@/components/Encabezado"
import Pie from "@/components/Pie"
import Buscar from "@/components/Buscar"
import Subida from "@/components/Subida";

import crc32 from "crc-32";

import { mapState, mapActions, mapMutations } from "vuex";

export default {
	name: "App",
	components: {
		Encabezado,
		Pie,
		Buscar,
		Subida,
	},
	data(){
		return {
			subida: []
		}
	},
	computed: {
		...mapState(["carpeta", "disco", "etiqueta", "categoria", "taxonomia"])
	},
	methods: {
		subidaTerminada(idu) {
			for (let i = 0; i < this.subida.length; i++) {
				//console.log(this.subida[i].id, idu);
				if (this.subida[i].id == idu) {
					this.subida.splice(i, 1);
					break;
					//console
				}
			}

			if (this.taxonomia == "carpeta") {
				this.obtenerArchivos({ id: this.carpeta.id });
			} else {
				this.obtenerArchivos({ id: this.categoria.id });
			}
			this.obtenerEtiquetas();
		},
		fileChanged(evt) {
			for (let i = 0; i < evt.target.files.length; i++) {
				var operacion = {
					id: uid(),
					archivo: evt.target.files[i]
				};
				this.subida.push(operacion);
			}
		},
		...mapActions([
			"obtenerArchivos",
			"obtenerCarpetas",
			"obtenerCarpeta",
			"obtenerEtiquetas"
		]),
	},
	created(){
		this.$store.dispatch( 'obtenerCategorias' );
		this.$store.dispatch( 'obtenerEtiquetas' );
	},
	mounted(){
		this.$root.$on("archivo-subir", () => {
			this.$refs.archivos.click();
		});

		this.$root.$on("archivo-agregar", (operacion) => {
			this.subida.push(operacion);
		});
	}
}

function uid() {
	const a = Math.random()
		.toString(36)
		.replace(/[^a-z]+/g, "")
		.substr(2);
	const b = Math.random()
		.toString(36)
		.substr(2);

	return a + b;
}

</script>

<style lang="stylus">
//@import "~sanitize.css/sanitize"
@import '~nib/index'
@import "~@stylus/base/utiles.styl"
@import "~@stylus/general"

#app
	margin 0
	padding 0
	//font-family: 'Roboto', sans-serif;
	//font-family: 'Courier', sans-serif;
	font-family: 'EMprint';
	font-weight: normal;
	font-style: normal;
	-webkit-font-smoothing: antialiased;
	-moz-osx-font-smoothing: grayscale;
	color azul
	height 100vh
	display grid
	grid-template-areas "encabezado" \
		"contenido" \
		"pie"
	grid-template-rows auto 1fr auto
	justify-content stretch
	align-items stretch

#encabezado
	grid-area encabezado
	//flex 0 0 auto

main
	box-sizing border-box
	//flex 1 0 auto
	grid-area contenido
	overflow auto
	align-items stretch
	background-color azul
	display grid
	grid-template-columns 1fr
	grid-template-rows 1fr


#pie
	grid-area pie
	//flex 0 0 auto

.fade-enter-active,
.fade-leave-active {
	transition-duration: 150ms;
	transition-property: opacity;
	transition-timing-function: ease;
}

.fade-enter,
.fade-leave-active {
	opacity: 0
}

.subidas{
	// grid-area subidas
	fixed: bottom left right;
	padding: .5rem .5rem 0;
	background-color: tint( azul, 80% );
	box-sizing: border-box;
	max-height: 100vh;
	overflow: auto;
}


.subidas .subida {
	margin-bottom: .5rem;
}

.archivos{
	position fixed
	top 0
	left 0
	z-index -1
	visibility hidden
}


</style>
